module FlexArrayGraphViz (module FlexArray, display) where
import FlexArray

-- Ginolas, Schmidt 2007
import Graphviz
toDot :: Show a => Flex a -> String
toDot x = 
	"digraph tmp {\n" ++
	concat nodes ++
	concat edges ++
	"}\n"
	where
		(nodes, edges, cnt, id) = hlp [] [] 0 x
		hlp :: Show a => [String] -> [String] -> Int -> (Flex a) -> ([String], [String], Int, String)
		hlp nodes edges cnt Null = (
			("  node [label=\"Null\",shape=ellipse]; "++idStr++";\n"):nodes,
			edges,
			cnt,
			""
			)
			where idStr = show cnt
		hlp nodes edges cnt (Leaf x) = (
			("  node [label=\"Node "++(show x)++"\",shape=ellipse]; "++idStr++";\n"):nodes,
			edges,
			cnt+1,
			idStr
			)
			where idStr = show cnt
		hlp nodes edges cnt (Fork x xt yt) = (
			("  node [label=\"Fork "++(show x)++"\",shape=box]; "++idStr++";\n"):nodes2,
			("  "++idStr++" -> "++id2++";\n") : ("  "++idStr++" -> "++id1++";\n") : edges2,
			cnt2+1,
			idStr
			) 
			where
				(nodes1, edges1, cnt1, id1) = hlp nodes edges cnt yt
				(nodes2, edges2, cnt2, id2) = hlp nodes1 edges1 cnt1 xt
				idStr = show cnt2

display :: Show a => Flex a -> IO ()
display x =
	do
	displayGraph (toDot x)

