{-
  Repraesenation eines Sets unter Verwendung von Listen
  Quelle: Richard Bird - Introduction to Functional Programming using Haskell
-}
                      
module LSet(Set, empty, isEmpty, insert, member, delete)
where
  newtype Set a = LSt ([a])
	deriving (Eq)
		

  --Dictionary-Funktionen
  
  --leere Menge
  empty :: Set a
  empty = LSt []
  
  --TeLSt auf leere Menge
  isEmpty :: Set a -> Bool
  isEmpty (LSt x) = null x
    
  --verbesserte Member-Funktion, arbeitet auf Basis einer sortierten Liste
  member :: (Ord a) => Set a -> a -> Bool
  member (LSt xs) x = if null ys then False
                          else (x == head ys)
		                      where
                            ys = dropWhile (<x) $ xs
  
  --loescht ein Element aus der Menge
  delete :: (Eq a) => a -> Set a -> Set a
  delete x (LSt xs) = LSt(filter (/=x) xs)

  --insert-Funktion ohne Duplikate, sortiert
  insert :: (Ord a) => a -> Set a -> Set a
  insert x (LSt xs) = LSt(ys ++ [x] ++ (filter (/=x) zs))
                             where
                             (ys, zs) = span (<x) xs  

  --Ausgabe eines Sets in der ueblichen Form {[Werte]}
  instance Show a => Show (Set a)
    where
    show (LSt xs)
      |null xs = "{}"
      |otherwise = '{':show' (LSt xs) ++ "}"
      where
        show' (LSt([])) = "" 
        show' (LSt(x:xs)) = show x ++ " " ++ show' (LSt xs)       
       
  
