module MySet where
import Test.HUnit
import LSet
--import TSet

-- Erzeuge leeren Set als Liste
eEmpty = empty

-- Erzeuge einen Set mit 1, 22, 33, 44, 55, 1
eFirstSet =(insert 22 (insert 33 (insert 44 (insert 55 (insert 1  (insert 1 eEmpty))))))

-- Löschen der 33
eDel = delete 33 eFirstSet

-- Prüfung ob ein Set leer ist 
eIsEmptyeDel = isEmpty eDel


-- Prüfung der Axiome mit HUnit

axiomTests = runTestTT axiomTestsList

axiomTestsList = TestList [	TestLabel "isEmptyTest with empty" isEmptyTest1, 
							TestLabel "isEmptyTest with non empty set" isEmptyTest2,
							TestLabel "member with empty set" memberTest1,
							TestLabel "member with non empty set" memberTest2,
							TestLabel "member with non empty set - searched item doesn't exist" memberTest3,
							TestLabel "insert two times with the same item" insertTest1,
							TestLabel "insert two times with the other items" insertTest2,
							TestLabel "delete an item from empty set" delete1,
							TestLabel "delete an item from empty set" delete2,
							TestLabel "delete an item from empty set" delete2a
							]


isEmptyTest1 :: Test
isEmptyTest1 = TestCase (assertEqual "isEmpty empty = true" (isEmpty empty) (True))

isEmptyTest2 :: Test
isEmptyTest2 = TestCase (assertEqual "isEmpty ( insert x xs ) = false" (isEmpty (insert 1 empty)) (False))

memberTest1 :: Test
memberTest1 = TestCase (assertEqual "member empty y = false" (member empty 1) (False))

memberTest2 :: Test
memberTest2 = TestCase (assertEqual "member ( insert x xs ) y = ( x = y ) || member xs y" ((member (insert 1 empty) 1 )) (True))

memberTest3 :: Test
memberTest3 = TestCase (assertEqual "member ( insert x xs ) y = ( x = y ) || member xs y" (member (insert 2 empty) 1) (False))

insertTest1 :: Test
insertTest1 = TestCase (assertEqual "insert x ( insert x xs ) = insert x xs" (insert 1 ( insert 1 empty )) (insert 1 empty))

insertTest2 :: Test
insertTest2 = TestCase (assertEqual "insert x ( insert y xs ) = insert y ( insert x xs )" (insert 1 ( insert 2 empty )) (insert 2 ( insert 1 empty )))

delete1  :: Test
delete1  = TestCase (assertEqual "delete x empty           = empty" (delete 1 empty) (empty))

-- delete x ( insert y xs ) = if x = y then delete x xs else insert y ( delete x xs )

delete2  :: Test
delete2  = TestCase (assertEqual "delete x ( insert y xs ) =  insert y ( delete x xs )" (delete 1  (insert 2 empty)) (insert 2 (delete 1 empty)))

delete2a  :: Test
delete2a  = TestCase (assertEqual "delete x ( insert y xs ) =  delete x xs" (delete 1  (insert 1 empty)) ((delete 1 empty)))
